--PLATAFORMA
CREATE TABLE PLATAFORMA (
ID_PLATAFORMA NUMBER CONSTRAINT PK_plataforma PRIMARY KEY,
desc_plataforma VARCHAR2(30 CHAR) CONSTRAINT NN_plataforma_desc NOT NULL,
tipo_plataforma NUMBER CONSTRAINT NN_tipo_plataforma NOT NULL
) ;
-- Tipo_plataforma=1 => web si tipo_plataforma=2 => Movil
--REDSOCIAL
CREATE TABLE REDSOCIAL (
ID_REDSOCIAL NUMBER CONSTRAINT PK_rsocial PRIMARY KEY,
nom_redsocial VARCHAR2(30 CHAR) CONSTRAINT NN_rsocial NOT NULL
) ; 
--DESCLEVEL
CREATE TABLE DESCLEVEL (
ID_LEVEL NUMBER CONSTRAINT PK_level PRIMARY KEY,
nom_level VARCHAR2(15 CHAR) CONSTRAINT NN_nomlevel NOT NULL,
desc_level VARCHAR2(30 CHAR) CONSTRAINT NN_desclevel NOT NULL,
start_date DATE CONSTRAINT NN_level_stDate NOT NULL,
end_date DATE,
CONSTRAINT CK_level_date CHECK (end_date IS NULL OR end_date > start_date)
) ;
--USUARIOS
CREATE TABLE USUARIOS (
ID_USER NUMBER CONSTRAINT PK_usuarios PRIMARY KEY,
sexo VARCHAR2(20 CHAR) CONSTRAINT NN_usrsex NOT NULL,
edad NUMBER CONSTRAINT NN_usredad NOT NULL,
ciudad VARCHAR2(30 CHAR) CONSTRAINT NN_usrcity NOT NULL,
profesion VARCHAR2(30 CHAR) CONSTRAINT NN_usrprofess NOT NULL,
start_date DATE CONSTRAINT NN_usr_startDate NOT NULL,
end_date DATE,
CONSTRAINT CK_usr_date CHECK (end_date IS NULL OR end_date > start_date),
status VARCHAR2(2 CHAR) CONSTRAINT NN_usrstatus NOT NULL,
no_cuenta_pago VARCHAR2(24 CHAR) CONSTRAINT NN_usrnocuenta NOT NULL,
LOGIN          VARCHAR2(50 CHAR) not null
) ;
-- Status OK=> Activo KO=> Inactivo
--AMIGOS
CREATE TABLE AMIGOS (
ID_AMIGO NUMBER,
id_user,
id_user_amigo,
id_redsocial NUMBER CONSTRAINT NN_amigos_rsocial NOT NULL,
start_date DATE CONSTRAINT NN_amigo_startDate NOT NULL,
end_date DATE,
CONSTRAINT CK_amido_date CHECK (end_date IS NULL OR end_date > start_date),
CONSTRAINT FK_amigos_user1 FOREIGN KEY (id_user) REFERENCES USUARIOS (id_user),
CONSTRAINT FK_amigos_user2 FOREIGN KEY (id_user_amigo) REFERENCES USUARIOS (id_user),
CONSTRAINT FK_amigos_rsocial FOREIGN KEY (id_redsocial) REFERENCES REDSOCIAL (id_redsocial),
CONSTRAINT PK_amigos PRIMARY KEY (id_amigo,id_user,id_user_amigo)
) ;
--VIDAS
CREATE TABLE VIDAS (
ID_VIDA NUMBER,
id_user,
start_date DATE CONSTRAINT NN_vida_startDate NOT NULL,
end_date DATE,
CONSTRAINT CK_vida_end_date CHECK (end_date IS NULL OR end_date > start_date),
CONSTRAINT FK_vida_user FOREIGN KEY (id_user) REFERENCES USUARIOS (id_user),
CONSTRAINT PK_vidas PRIMARY KEY (id_vida, id_user)
) ;
--AYUDAS
CREATE TABLE AYUDA (
ID_AYUDA NUMBER,
id_user NUMBER NOT NULL,
time_stamp DATE NOT NULL,
id_level NOT NULL,
CONSTRAINT FK_ayuda_level FOREIGN KEY (id_level) REFERENCES videoadmin.DESCLEVEL (id_level),
CONSTRAINT PK_ayuda PRIMARY KEY (id_ayuda)
) ;
--Dailylevel
CREATE TABLE DAILYLEVEL (
id_user,
id_level,
start_date DATE,
end_date DATE,
CONSTRAINT CK_dl_end_date CHECK (end_date IS NULL OR end_date > start_date),
CONSTRAINT FK_dl_user FOREIGN KEY (id_user) REFERENCES USUARIOS (id_user),
CONSTRAINT FK_dl_level FOREIGN KEY (id_level) REFERENCES DESCLEVEL (id_level),
CONSTRAINT PK_daylylevel PRIMARY KEY (id_user, id_level,start_date)
) ;
--TRANSCAYUDAAMIGOS
CREATE TABLE TRANSCAYUDAAMIGOS (
ID_TRANS_AYUDA NUMBER CONSTRAINT PK_transcamigo PRIMARY KEY,
Id_user_emisor NUMBER CONSTRAINT NN_transcamigo_ue NOT NULL,
Id_user_receptor NUMBER CONSTRAINT NN_transcamigo_ur NOT NULL,
Time_stamp DATE CONSTRAINT NN_transcamigo_ts NOT NULL,
ID_VIDA NUMBER CONSTRAINT NN_vida_tra NOT NULL,
TranscRErrorLog VARCHAR2(50 CHAR) CONSTRAINT NN_transcamigo_terr NOT NULL,
TranscCorrect VARCHAR2(50 CHAR) CONSTRAINT NN_transcamigo_tok NOT NULL,
Id_redsocial NUMBER CONSTRAINT NN_transcamigo_rs NOT NULL,
CONSTRAINT FK_user_emisor FOREIGN KEY (Id_user_emisor) REFERENCES USUARIOS (id_user),
CONSTRAINT FK_user_receptor FOREIGN KEY (Id_user_receptor) REFERENCES USUARIOS (id_user),
CONSTRAINT FK_transcamigo_rsocial FOREIGN KEY (id_redsocial) REFERENCES REDSOCIAL (id_redsocial)
) ;
--USADA
CREATE TABLE USADA (
id_vida,
id_user,
id_level,
start_date DATE CONSTRAINT NN_usada_startDate NOT NULL,
end_date DATE,
CONSTRAINT CK_usada_end_date CHECK (end_date IS NULL OR end_date > start_date),
CONSTRAINT FK_usada_vida FOREIGN KEY (id_vida,id_user) REFERENCES VIDAS (id_vida,id_user),
CONSTRAINT FK_usada_level FOREIGN KEY (id_level) REFERENCES DESCLEVEL (id_level),
CONSTRAINT PK_usada PRIMARY KEY (id_vida, id_user, id_level)
) ;
--ESTAR_EN_RS ---- OJO, esta tabla no se usa finalmente """"""""""""""""""""""""""""""""""""""""""""""""""
CREATE TABLE ESTAR_EN_RS (
ID_AMIGO,
id_user,
id_user_amigo,
id_redsocial,
start_date DATE CONSTRAINT NN_estarenrs_startDate NOT NULL,
end_date DATE,
CONSTRAINT CK_estarenrs_end_date CHECK (end_date IS NULL OR end_date > start_date),
CONSTRAINT FK_estarenrs_amigos FOREIGN KEY (id_amigo,id_user,id_user_amigo) REFERENCES AMIGOS (id_amigo,id_user,id_user_amigo),
CONSTRAINT FK_estarenrs_rs FOREIGN KEY (id_redsocial) REFERENCES REDSOCIAL (id_redsocial),
CONSTRAINT PK_estarenrs PRIMARY KEY (id_amigo, id_user,id_user_amigo,id_redsocial)
) ;
--Productos
CREATE TABLE PRODUCTOS (
ID_PRODUCTO NUMBER,
precio NUMBER,
Id_tipo_compra NUMBER CONSTRAINT NN_producto NOT NULL,
desc_producto VARCHAR2(30 CHAR) CONSTRAINT NN_producto_desc NOT NULL,
start_date DATE CONSTRAINT NN_producto_startDate NOT NULL,
end_date DATE,
CONSTRAINT CK_product_date CHECK (end_date IS NULL OR end_date > start_date),
CONSTRAINT PK_productos PRIMARY KEY (id_producto, precio)
) ;
--ERROR_COMPRA
CREATE TABLE ERROR_COMPRA (
ID_ERROR_COMPRA NUMBER CONSTRAINT PK_errcompra PRIMARY KEY,
desc_error_compra VARCHAR2(50 CHAR) CONSTRAINT NN_errcompra NOT NULL
) ; 
--COMPRAS
CREATE TABLE COMPRAS (
ID_COMPRA NUMBER,
Id_user,
fecha_compra DATE CONSTRAINT NN_fecha_compra NOT NULL,
Id_plataforma NUMBER CONSTRAINT NN_compra_platf NOT NULL,
Id_error_compra NUMBER,
id_level NUMBER CONSTRAINT NN_compra_level NOT NULL,
Estado_Compra VARCHAR2(10 CHAR) CONSTRAINT NN_status_compra NOT NULL,
CONSTRAINT FK_user_compra FOREIGN KEY (Id_user) REFERENCES USUARIOS (id_user),
CONSTRAINT FK_error_compra FOREIGN KEY (Id_error_compra) REFERENCES ERROR_COMPRA (Id_error_compra),
CONSTRAINT FK_platform_compra FOREIGN KEY (Id_plataforma) REFERENCES PLATAFORMA (Id_plataforma),
CONSTRAINT PK_compras PRIMARY KEY (id_compra, id_user)
) ;
--INCLUIR_COMPRA
CREATE TABLE INCLUIR_COMPRA (
Id_compra,
Id_user,
Id_producto,
precio,
cantidad NUMBER CONSTRAINT NN_compra_cantidad NOT NULL,
CONSTRAINT FK_compras FOREIGN KEY (Id_compra,Id_user) REFERENCES COMPRAS (Id_compra,id_user),
CONSTRAINT FK_producto_compra FOREIGN KEY (Id_producto,precio) REFERENCES PRODUCTOS (Id_producto,precio),
CONSTRAINT PK_incluircompra PRIMARY KEY (Id_compra, id_user, Id_producto, precio)
) ;

--PROCESOS --Tabla que almacena los distintos procesos que se ejecutan en la BD de cara a almacenar logs de procesos.
CREATE TABLE PROCESOS (
ID_PROCESO NUMBER CONSTRAINT PK_procesos PRIMARY KEY,
NOM_proceso VARCHAR2(30 CHAR) CONSTRAINT NN_procesos_nom NOT NULL,
desc_proceso VARCHAR2(30 CHAR) CONSTRAINT NN_procesos_desc NOT NULL
) ; 

--PROCESOS_LOG --Tabla que almacena informacin de ejecucin de cada proceso.
CREATE TABLE PROCESOS_LOG (
ID_PROCESO_LOG NUMBER CONSTRAINT PK_procesolog PRIMARY KEY,
id_proceso,
id_user NUMBER CONSTRAINT NN_usrerproceso NOT NULL,
start_date DATE CONSTRAINT NN_proceso_startDate NOT NULL,
end_date DATE,
status VARCHAR2(2 CHAR) CONSTRAINT NN_procesostatus NOT NULL,
CONSTRAINT CK_proceso_date CHECK (end_date IS NULL OR end_date >= start_date),
CONSTRAINT FK_proceso FOREIGN KEY (id_proceso) REFERENCES PROCESOS (id_proceso)
) ;
-- status  OK -- ERR (error) -- STR(en ejecucin)








