---------------------------------------------
-- Export file for user VIDEOADMIN         --
-- Created by Dell on 13/01/2014, 20:56:06 --
---------------------------------------------

spool 7_Procesos_Almacenados_Procedures.log

prompt
prompt Creating procedure ACTUALIZAR_VIDA_DIARIO
prompt =========================================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.ACTUALIZAR_VIDA_DIARIO IS

i NUMBER;
j NUMBER;

CURSOR VIDAS_USUARIOS 
    IS
    select v.*
    from videoadmin.usuarios u, videoadmin.vidas v
    where u.end_date is null 
    and u.status='OK'
    and u.id_user=v.id_user
    and v.end_date is null 
    and v.id_vida not in (select u.id_vida 
                          from videoadmin.usada u 
                          where u.end_date is null);
                          
CURSOR LISTA_USUARIOS 
    IS
    select u.*
    from videoadmin.usuarios u
    where u.end_date is null 
    and u.status='OK';
    
BEGIN
  
    FOR i IN VIDAS_USUARIOS LOOP
      --Se finalizan las vidas que no se han usado y no estn en uso.
      
      update videoadmin.vidas v set v.end_date=sysdate
      where v.id_vida=i.id_vida;
      COMMIT;  
    
    END LOOP;
    FOR j IN LISTA_USUARIOS LOOP
     
      --Se renuevan 5 vidas a cada usuario a parte de las que ya estan usando.
         
    INSERT INTO videoadmin.VIDAS VALUES(0,j.id_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,j.id_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,j.id_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,j.id_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,j.id_user, to_date(sysdate,'DD/MM/YYYY'), null);

    COMMIT;  
    
    END LOOP;
  
  
  
END;
/

prompt
prompt Creating procedure AGREGAR_AMIGO
prompt ================================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.AGREGAR_AMIGO
(xid_user VIDEOADMIN.USUARIOS.ID_USER%TYPE,xid_amigo VIDEOADMIN.USUARIOS.ID_USER%TYPE, xid_redsocial VIDEOADMIN.Redsocial.ID_REDSOCIAL%TYPE)
IS

x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;

x_useraux NUMBER:=0;
x_exitst NUMBER:=0;
Excepcion Varchar(7) :='NNNNNNN';

BEGIN
---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='AGREGAR_AMIGO';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_user,sysdate,null,'RN');--RN Running
     --SE obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
    END IF; 
---***************************************************************************  


 BEGIN
  --Se comprueba que exista el usuario al qe se le agrega un amigo
   select usr.id_user
   INTO x_useraux
   from videoadmin.usuarios usr
   where usr.id_user=xid_user
   and usr.end_date is null;
   exception
   when no_data_found then
     Excepcion:='NO_USR';
  END;
 IF (Excepcion<>'NO_USR')THEN
  BEGIN
   BEGIN
  --Se comprueba que exista el amigo a agregar.
     select usr.id_user
     INTO x_useraux
     from videoadmin.usuarios usr
     where usr.id_user=xid_amigo
     and usr.end_date is null;
       exception
         when no_data_found then
           Excepcion:='NO_AMI';
   END;
    IF (Excepcion<>'NO_AMI')THEN
        BEGIN
          BEGIN
        --Se comprueba que no exista la relacin de amigos en la tabla amigos con la misma red social.
          select 1
          INTO x_exitst
          from videoadmin.amigos am
          where (am.id_user=xid_user
          and am.id_user_amigo=xid_amigo
          and am.id_redsocial=xid_redsocial
          and am.end_date is null)
          OR (am.id_user=xid_amigo
          and am.id_user_amigo=xid_user
          and am.id_redsocial=xid_redsocial
          and am.end_date is null);
            exception
              when no_data_found then
              x_exitst:=0;
          END;    
          IF x_exitst=0 THEN
           BEGIN
           INSERT INTO videoadmin.amigos VALUES(0,xid_user,xid_amigo,xid_redsocial,to_date(sysdate,'DD/MM/YYYY'), null);
            COMMIT;
           END;
            ELSE
               DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El usuario ya lo tiene asignado como amigo !! ');
            END IF;
        END;
       ELSE  
         DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, Usuario amigo no esixte en el sistema !! ');
       END IF;
   END;
    ELSE
   DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, Usuario no existe en el sistema. !! ');
  END IF;
  ---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 AND x_exitst=0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_user;
     COMMIT;
    END;
   ELSE
          BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************     
    
END;
/

prompt
prompt Creating procedure ALTA_USUARIO
prompt ===============================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.ALTA_USUARIO
(sexo VARCHAR2, edad NUMBER, ciudad VARCHAR2, profesion VARCHAR2, No_cuenta VARCHAR2, xlogin_u VIDEOADMIN.USUARIOS.LOGIN%TYPE)
IS

usr_exist NUMBER:=0;
xid_user NUMBER;

x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;

BEGIN
  ---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='ALTA_USUARIO';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, 0,sysdate,null,'RN');--RN Running
     --SE obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
    END IF; 
---***************************************************************************  

    select count(ut.login)
    INTO usr_exist
     from videoadmin.usuarios ut
    where ut.login=xlogin_u;
 
 IF usr_exist=0 THEN
  BEGIN
     INSERT INTO videoadmin.USUARIOS VALUES(usr_exist,sexo, edad, ciudad, profesion, sysdate, null, 'OK', No_cuenta,xlogin_u);
     COMMIT;
          
    select max(ut.id_user)
    INTO xid_user
     from videoadmin.usuarios ut 
    where ut.login=xlogin_u;
     
    INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
    INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
        COMMIT;
     INSERT INTO videoadmin.dailylevel VALUES(xid_user,1, to_date(sysdate,'DD/MM/YYYY'), null);
        COMMIT; 
    
  END;
   ELSE

   DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, Login de Usuario existente !! ');
  END IF;
  
    ---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 AND usr_exist=0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK' , pl.id_user=xid_user
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso;
     COMMIT;
    END;
   ELSE
          BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************   
  
  
END;
/

prompt
prompt Creating procedure BAJA_USUARIO
prompt ===============================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.BAJA_USUARIO
(xid_user VIDEOADMIN.USUARIOS.ID_USER%TYPE)
IS

x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;
x_usuario NUMBER :=0;
x_usuarioa NUMBER :=0;
x_usuariodl NUMBER :=0;
x_usuariov NUMBER :=0;
x_usuariou NUMBER :=0;

BEGIN
---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='BAJA_USUARIO';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_user,sysdate,null,'RN');--RN Running
     --Se obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
    END IF; 
---***************************************************************************     
--select * from videoadmin.amigos a where a.id_amigo=26 or a.id_user=26 or a.id_user_amigo=26;
   BEGIN
   select usr.id_user
    INTO x_usuario
     from videoadmin.usuarios usr
    where usr.id_user=xid_user
    and usr.end_date is null
    and usr.status='OK';
   exception
      when no_data_found then
        x_error:=2;
   END; 
   
    If x_error = 0 THEN
    BEGIN
        select count(dl.id_user)
          INTO x_usuariodl
        from videoadmin.dailylevel dl
        where dl.id_user=xid_user
        and dl.end_date is null;
        
        select count(v.id_user)
          INTO x_usuariov
        from videoadmin.vidas v
        where v.id_user=xid_user
        and v.end_date is null;
        
        select count(u.id_user)
          INTO x_usuariou
        from videoadmin.usada u
        where u.id_user=xid_user
        and u.end_date is null;
        
         select count(a.id_user)
          INTO x_usuarioa
        from videoadmin.amigos a
        where (a.id_amigo=xid_user or a.id_user=xid_user or a.id_user_amigo=xid_user)
        and a.end_date is null;
        
 --select * from videoadmin.amigos a where a.id_amigo=26 or a.id_user=26 or a.id_user_amigo=26;       
       END; 
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el Usuario en el sistema o ya est dado de baja!! ');
    END IF; 

    IF x_usuariodl > 0 THEN
      BEGIN
       update videoadmin.dailylevel dl
         set dl.end_date=sysdate
        where dl.id_user=xid_user
        and dl.end_date is null;
      END;
      ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           'Usuario no tiene actividad diaria!! ');
      END IF;

    IF x_usuariov > 0 THEN
       BEGIN
       update videoadmin.vidas v
         set v.end_date=sysdate
        where v.id_user=xid_user
        and v.end_date is null;
       END;
       ELSE
        DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Usuario no tiene vidas activas!! ');
       END IF;

   IF x_usuariou > 0 THEN
       BEGIN
         update videoadmin.usada u
         set u.end_date=sysdate
         where u.id_user=xid_user
        and u.end_date is null;
       END;
       ELSE
         DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Usuario no tiene vidas en uso actualmente!! ');
       END IF;

   IF x_usuarioa > 0 THEN
       BEGIN
         update videoadmin.amigos a
         set a.end_date=sysdate
         where (a.id_amigo=xid_user or a.id_user=xid_user or a.id_user_amigo=xid_user)
          and a.end_date is null;
       END;
       ELSE
       DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Usuario no tiene amigos actualmente!! ');
       END IF;
      
   IF x_error = 0 THEN
     BEGIN
       update videoadmin.usuarios usr
         set usr.end_date=sysdate, usr.status='KO'
         where usr.id_user=xid_user
        and usr.end_date is null
        and usr.status='OK';
     END;
    ELSE
       DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Usuario no existe!! ');
    END IF; 
---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_user;
     COMMIT;
    END;
   ELSE
        BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************     
       
  
END;
/

prompt
prompt Creating procedure COMPRAR_VIDA_AYUDA
prompt =====================================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.COMPRAR_VIDA_AYUDA
(xid_user VIDEOADMIN.USUARIOS.ID_USER%TYPE,xid_plataforma VIDEOADMIN.Plataforma.ID_PLATAFORMA%TYPE,
x_tipocompra VIDEOADMIN.Productos.ID_TIPO_COMPRA%TYPE, x_cantidad VIDEOADMIN.incluir_compra.CANTIDAD%TYPE )
IS

x_error NUMBER:=0;
x_idproceso NUMBER:=0;
x_level NUMBER :=0;
x_idproducto NUMBER :=0;
x_precio NUMBER :=0;
x_idcompra NUMBER :=0;
x_procesolog NUMBER :=0;
x_compra NUMBER :=0; --0(No existe compra) 1(vida) 2(ayuda)
x_cantidad_aux NUMBER:= x_cantidad;

BEGIN
---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='COMPRAR_VIDA_AYUDA';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_user,sysdate,null,'RN');--RN Running
     --SE obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
    END IF; 
---***************************************************************************     

--Se obtiene el nivel actual en el que se encuentra el usuario
  BEGIN
  select dl.id_level 
    INTO x_level
  from videoadmin.dailylevel dl 
  where dl.id_user=xid_user and dl.end_date is null;
  exception
      when no_data_found then
        x_error:=2;
   END;
  
  If x_error = 0 THEN
    BEGIN  --**********COMPRA*********
     --Si el producto a comprar es una una vida (x_tipocompra=1)
     If x_tipocompra = 1 THEN
       BEGIN
     -- Se obtiene el producto a comprar de VIDA.
       select pr.id_producto,pr.precio 
        INTO x_idproducto, x_precio
       from videoadmin.productos pr 
       where pr.id_tipo_compra=1
       and pr.end_date is null
       and UPPER(pr.desc_producto)=(select 'VIDA ' || UPPER(de.nom_level)
                                    from videoadmin.dailylevel dl, videoadmin.desclevel de
                                    where dl.id_user=xid_user 
                                    and dl.end_date is null
                                    and de.id_level=dl.id_level);
         x_compra := 1;
         exception
         when no_data_found then
           x_error:=3;
        END;
        --**********AYUDA*********
       ELSE IF x_tipocompra = 2 THEN --Si el producto a comprar es una ayuda
               BEGIN
                -- Se obtiene el producto a comprar de VIDA.
                select pr.id_producto,pr.precio 
                 INTO x_idproducto, x_precio
                from videoadmin.productos pr 
                where pr.id_tipo_compra=2
                and pr.end_date is null
                and UPPER(pr.desc_producto)=(select 'AYUDA ' || UPPER(de.nom_level)
                                    from videoadmin.dailylevel dl, videoadmin.desclevel de
                                    where dl.id_user=xid_user 
                                    and dl.end_date is null
                                    and de.id_level=dl.id_level);
                 x_compra := 2;
               exception
                when no_data_found then
                x_error:=4;
              END;
           ELSE
             DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No tipo de compra o producto incorrecto!! ');   
                            
           END IF; 
        END IF; 
     --Se almacenan los datos de compra dependiendo si se tarta de una vida o una ayuda
     If x_compra = 1 THEN
       BEGIN
         INSERT INTO videoadmin.compras VALUES(0,xid_user,sysdate,xid_plataforma,null,x_level,'OK');
       -- Almacenamos el id_compra en x_idcompra
         select videoadmin.seq_compra.currval
           INTO x_idcompra
         from dual;
       INSERT INTO videoadmin.incluir_compra VALUES(x_idcompra,xid_user,x_idproducto,x_precio,x_cantidad);
        WHILE (x_cantidad_aux>0) LOOP
             x_cantidad_aux := x_cantidad_aux -1;
	           INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
	        END LOOP;
         END; 
       ELSE IF x_compra = 2 THEN --SI se trata de la compra de una o varias ayudas
               BEGIN
            --x_idproducto, x_precio , x_cantidad  , xid_user, xid_plataforma , x_tipocompra
              INSERT INTO videoadmin.compras VALUES(0,xid_user,sysdate,xid_plataforma,null,x_level,'OK');
              -- Almacenamos el id_compra en x_idcompra
              select videoadmin.seq_compra.currval
               INTO x_idcompra
              from dual;
              INSERT INTO videoadmin.incluir_compra VALUES(x_idcompra,xid_user,x_idproducto,x_precio,x_cantidad);
             WHILE (x_cantidad_aux>0) LOOP
                x_cantidad_aux := x_cantidad_aux -1;
	              INSERT INTO videoadmin.ayuda VALUES(0,xid_user, sysdate, x_level);
	           END LOOP;
            END;
          END IF;  
      END IF;
     
      END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No se encuentra nivel de usuario. Tal vez haya finalizado la partida completa!! ');
    END IF; 

---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_user;
     COMMIT;
    END;
   ELSE
         BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************     

END;
/

prompt
prompt Creating procedure ESTADISTICAS
prompt ===============================
prompt
create or replace procedure videoadmin.ESTADISTICAS is
begin
  --Procedure que lanza el proceso de estadsiticas para todas las tablas del usuario VIDEOADMIN.
  --AL tratarse de una Base de datos con poco volumen de datos, es deci muy pequea, se lanza el proceso para que
  -- se analicen todas las tablas del usuario al 100%
   
   Begin
     DBMS_STATS.GATHER_SCHEMA_STATS (
     ownname => 'videoadmin',
     estimate_percent => 100);
    end;
  
end ESTADISTICAS;
/

prompt
prompt Creating procedure FINALIZAR_VIDA
prompt =================================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.FINALIZAR_VIDA
(xid_user VIDEOADMIN.USUARIOS.ID_USER%TYPE)
IS

x_vida NUMBER:=0;
x_exitst NUMBER:=0;

x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;

BEGIN
 ---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='FINALIZAR_VIDA';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_user,sysdate,null,'RN');--RN Running
     --SE obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
    END IF; 
---***************************************************************************  
  
  BEGIN
  --Se comprueba si la vida a eliminar se esta usando obteniendose el id_de la vida en uso
   select min(us.id_vida)
   INTO x_vida
   from videoadmin.usada us
   where us.id_user=xid_user
   and us.end_date is null;
   
  END;
   
 IF x_vida IS NOT NULL THEN
  BEGIN
  
     UPDATE videoadmin.usada us
     set us.end_date=sysdate
     where us.id_vida=x_vida
     and us.id_user=xid_user;
     COMMIT;
     
     UPDATE videoadmin.vidas v
     set v.end_date=sysdate
     where v.id_vida=x_vida
     and v.id_user=xid_user;
     COMMIT;
     x_exitst:=0;

  END;
   ELSE
    x_exitst:=1;
   DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, Usuario con vidas agotadas !! ');
  END IF;
  
   ---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 AND x_exitst=0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_user;
     COMMIT;
    END;
   ELSE
          BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---*************************************************************************** 

END;
/

prompt
prompt Creating procedure REACTIVAR_USUARIO
prompt ====================================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.REACTIVAR_USUARIO
(xid_user VIDEOADMIN.USUARIOS.ID_USER%TYPE)
IS

x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;
x_usuario NUMBER :=0;
x_usuarioa NUMBER :=0;

BEGIN
---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='REACTIVAR_USUARIO';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_user,sysdate,null,'RN');--RN Running
     --Se obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
    END IF; 
---***************************************************************************     
--select * from videoadmin.amigos a where a.id_amigo=26 or a.id_user=26 or a.id_user_amigo=26;
   BEGIN
   select usr.id_user
    INTO x_usuario
     from videoadmin.usuarios usr
    where usr.id_user=xid_user
    and usr.end_date is not null
    and usr.status='KO';
   exception
      when no_data_found then
        x_error:=2;
   END; 
   
    If x_error = 0 THEN
    BEGIN
         select count(a.id_user)
          INTO x_usuarioa
        from videoadmin.amigos a
        where (a.id_amigo=xid_user or a.id_user=xid_user or a.id_user_amigo=xid_user)
        and a.end_date is not null;
        
 --select * from videoadmin.amigos a where a.id_amigo=26 or a.id_user=26 or a.id_user_amigo=26;       
       END; 
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el Usuario en el sistema o ya est dado de baja!! ');
    END IF; 

    
   IF x_usuarioa > 0 THEN
       BEGIN
         update videoadmin.amigos a
         set a.end_date=null
         where (a.id_amigo=xid_user or a.id_user=xid_user or a.id_user_amigo=xid_user)
          and a.end_date is not null;
       END;
       ELSE
       DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Usuario no teia amigos asignados!! ');
       END IF;
      
   IF x_error = 0 THEN
     BEGIN
       update videoadmin.usuarios usr
         set usr.end_date=null, usr.status='OK'
         where usr.id_user=xid_user
        and usr.end_date is not null
        and usr.status='KO';
        --Se crean las cinco vidas iniciales
          
       INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
       INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
       INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
       INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
       INSERT INTO videoadmin.VIDAS VALUES(0,xid_user, to_date(sysdate,'DD/MM/YYYY'), null);
       -- Inicia el dailylevel desde el nivel 1
       INSERT INTO videoadmin.dailylevel VALUES(xid_user,1, to_date(sysdate,'DD/MM/YYYY'), null);    
     END;
    ELSE
       DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Usuario no existe!! ');
    END IF; 
---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_user;
     COMMIT;
    END;
   ELSE
          BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************     
       
  
END;
/

prompt
prompt Creating procedure SUPERAR_NIVEL
prompt ================================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.SUPERAR_NIVEL
(xid_user VIDEOADMIN.USUARIOS.ID_USER%TYPE)
IS

x_levela NUMBER:=0;-- nivel actual
x_leveln NUMBER:=0;--nivel nuevo
x_vida NUMBER:=0;
x_exitst NUMBER:=0;

x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;


BEGIN
---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='SUPERAR_NIVEL';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_user,sysdate,null,'RN');--RN Running
     --SE obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
    END IF; 
---***************************************************************************   
  
  BEGIN
  --Se obtiene el nivel actual del usuario para darle de baja e insertar el nuevo nivel.
   select dl.id_level
   INTO x_levela
   from videoadmin.dailylevel dl
   where dl.id_user=xid_user
   and dl.end_date is null;
   
  END;
   
 IF x_levela IS NOT NULL THEN
  BEGIN
   if x_levela = 5 THEN
      x_leveln:= 1;
   else  x_leveln:= x_levela+1;
   end if;
   
     UPDATE videoadmin.dailylevel dl
     set dl.end_date=sysdate
     where dl.id_level=x_levela
     and dl.id_user=xid_user;
     COMMIT;
     
      INSERT INTO videoadmin.dailylevel VALUES(xid_user,x_leveln, to_date(sysdate,'DD/MM/YYYY'), null);
        COMMIT; 
   
     select min(v.id_vida)
      INTO x_vida
     from videoadmin.vidas v
     where v.id_user=xid_user
     and v.end_date is null;
   
     UPDATE videoadmin.usada us
     set us.end_date=sysdate
     where us.id_level=x_levela
     and us.id_user=xid_user
     and us.id_vida=x_vida;
     COMMIT;
     
      INSERT INTO videoadmin.usada VALUES(x_vida,xid_user,x_leveln,to_date(sysdate,'DD/MM/YYYY'), null);
     COMMIT;
      
     x_exitst :=0;

  END;
   ELSE
       BEGIN
       DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, nivel no detectado !! ');
          x_exitst :=1;
       END;
                           
  END IF;
  
  ---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 AND x_exitst=0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_user;
     COMMIT;
    END;
   ELSE
          BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************  
  
END;
/

prompt
prompt Creating procedure TRANSFERIR_VIDA
prompt ==================================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.TRANSFERIR_VIDA
(xid_useremisor VIDEOADMIN.USUARIOS.ID_USER%TYPE,xid_userreceptor VIDEOADMIN.USUARIOS.ID_USER%TYPE, xid_redsocial VIDEOADMIN.Redsocial.ID_REDSOCIAL%TYPE)
IS

x_exitst NUMBER:=0;
x_dispVida NUMBER:=0;

x_control NUMBER:=0;
x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;

BEGIN
   ---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='TRANSFERIR_VIDA';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_useremisor,sysdate,null,'RN');--RN Running
     --SE obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
         BEGIN
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
            x_control :=1;
         END;
    END IF; 
---***************************************************************************  
  BEGIN
  --Se comprueba si los usuarios estn conectados a travs de la red social indicada.
   select 1 
   INTO x_exitst
   from videoadmin.amigos am 
   where (am.id_user=xid_useremisor and am.id_user_amigo=xid_userreceptor and am.id_redsocial=xid_redsocial)
          OR
         (am.id_user_amigo=xid_useremisor and am.id_user=xid_userreceptor and am.id_redsocial=xid_redsocial);
    exception
    when no_data_found then
     x_exitst:=0;
  END;
   
  IF x_exitst=1 THEN
     BEGIN
     --Se comrueba Si el usuario emisor tiene una vida disponible a parte de la que est usando    
      select NVL(min(v.id_vida),0)
      INTO x_dispVida
      from videoadmin.vidas v where v.id_user=xid_useremisor
      and v.end_date is null 
      and not exists (select us.id_vida 
                      from videoadmin.usada us 
                      where us.id_user=xid_useremisor and us.id_vida=v.id_vida) ;
     exception
      when no_data_found then
        x_dispVida:=0;
        END;
       IF x_dispVida<>0 THEN
         BEGIN
          INSERT INTO videoadmin.transcayudaamigos VALUES(0,xid_useremisor,xid_userreceptor,sysdate,x_dispVida,'NO ERROR','OK',xid_redsocial);
          COMMIT;
          
          UPDATE videoadmin.vidas v
          set v.id_user=xid_userreceptor
          where v.id_vida=x_dispVida
          and v.id_user=xid_useremisor;
           COMMIT;
        END;
       ELSE
         BEGIN
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El usuario emisor no dispone de vidas para transferir!! ');
           x_control :=1;
         END;
      END IF;
      
  ELSE
     BEGIN
     DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, Los usuarios no estn conectados a travs de una red social!! ');
       x_control :=1;
         END;
     END IF;
     
  ---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 AND x_control=0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_useremisor;
     COMMIT;
    END;
   ELSE
          BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_useremisor;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************     
        
END;
/

prompt
prompt Creating procedure USAR_VIDA
prompt ============================
prompt
CREATE OR REPLACE PROCEDURE VIDEOADMIN.USAR_VIDA
(xid_user VIDEOADMIN.USUARIOS.ID_USER%TYPE)
IS

x_vida NUMBER:=0;
x_level NUMBER:=0;
Excepcion Varchar(7) :='NNNNNNN';

x_control NUMBER:=0;
x_idproceso NUMBER:=0;
x_error NUMBER:=0;
x_procesolog NUMBER :=0;
x_vuso NUMBER :=0; --Control de vidas en uso

BEGIN
---***************************************************************************   
  BEGIN
  --Se obtiene el proceso para crear la entrada del proceso de compra de vida o ayuda.
   select pr.id_proceso
   INTO x_idproceso
   from videoadmin.procesos pr 
   where pr.nom_proceso='USAR_VIDA';
    exception
    when no_data_found then
     x_error:=1;
  END;
  If x_error = 0 THEN
    BEGIN
     INSERT INTO videoadmin.procesos_log VALUES(0,x_idproceso, xid_user,sysdate,null,'RN');--RN Running
     --SE obtiene el id del proceso log generado con la secuencia
        select videoadmin.seq_proceso_log.currval
          INTO x_procesolog
         from dual;     
    END;
    ELSE
         BEGIN
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, No existe el proceso definido en la BD!! ');
         x_control:=1;
         END;
    END IF; 
---***************************************************************************  

 BEGIN
  --Se obtiene la primera vida disponible
   select min(v.id_vida)
   INTO x_vida
   from videoadmin.vidas v
   where v.id_user=xid_user
   and v.end_date is null;
   exception
   when no_data_found then
     Excepcion:='NO_VIDA';
  END;
 IF (Excepcion<>'NO_VIDA')THEN
  BEGIN
  --Se comprueba que el usuario no tenga una vida en uso ya que un usuario solo puede tener una vida en uso y no mas.
    select count(*) 
     INTO x_vuso
    from videoadmin.usada u 
    where u.end_date is null 
    and u.id_user=xid_user;
    
     IF x_vuso = 0 THEN
       BEGIN
            select d.id_level
             INTO x_level
            from videoadmin.dailylevel d
            where d.id_user=xid_user
            and d.end_date is null;

         INSERT INTO videoadmin.usada VALUES(x_vida,xid_user,x_level,to_date(sysdate,'DD/MM/YYYY'), null);
        COMMIT;
       
       END;
       ELSE
            DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, Un usuario No puede usar dos vidas a la vez  !! ');
               x_control:=1;
       END IF;
    END;
   ELSE
     BEGIN
       DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, Usuario con vidas agotadas !! ');
      x_control:=1;
         END;
  END IF;
   ---SI no ha habido errores, se actualiza el proceso log 
---***************************************************************************   
   If x_error = 0 AND x_control=0 THEN
     BEGIN
     update videoadmin.procesos_log pl
     set pl.end_date = sysdate, pl.status ='OK'
     where pl.id_proceso_log=x_procesolog 
     and pl.id_proceso=x_idproceso
     and pl.id_user=xid_user;
     COMMIT;
    END;
   ELSE
          BEGIN
            update videoadmin.procesos_log pl
             set pl.end_date = sysdate, pl.status ='KO'
            where pl.id_proceso_log=x_procesolog 
            and pl.id_proceso=x_idproceso
            and pl.id_user=xid_user;
            COMMIT;
          DBMS_OUTPUT.PUT_LINE(to_char(sysdate, 'dd/mm/yy HH24:MI:SS') ||
                           ' Error, El proceso acabo con errores! ');
          END;
    END IF; 
---***************************************************************************     
  
END;
/


spool off
