--Creacin DWH tablas de hecho y dimensiones.

--Dimensin usuario
CREATE TABLE d_usuario (
ID_USER NUMBER CONSTRAINT PK_usuarios_d PRIMARY KEY,
sexo VARCHAR2(20 CHAR) CONSTRAINT NN_usrsex_d NOT NULL,
edad NUMBER CONSTRAINT NN_usredad_d NOT NULL,
ciudad VARCHAR2(30 CHAR) CONSTRAINT NN_usrcity_d NOT NULL,
profesion VARCHAR2(30 CHAR) CONSTRAINT NN_usrprofess_d NOT NULL,
status VARCHAR2(2 CHAR) CONSTRAINT NN_usrstatus_d NOT NULL
) ; 
-- Status OK=> Activo KO=> Inactivo

--Dimensin PLATAFORMA
CREATE TABLE d_plataforma (
ID_PLATAFORMA NUMBER CONSTRAINT PK_plataforma_d PRIMARY KEY,
desc_plataforma VARCHAR2(30 CHAR) CONSTRAINT NN_plataforma_desc_d NOT NULL
) ;

-- Dimension Nivel
CREATE TABLE d_nivel (
ID_LEVEL NUMBER CONSTRAINT PK_level_d PRIMARY KEY,
nom_level VARCHAR2(15 CHAR) CONSTRAINT NN_nomlevel_d NOT NULL
) ;

--Dimension REDSOCIAL
CREATE TABLE d_redsocial (
ID_REDSOCIAL NUMBER CONSTRAINT PK_rsocial_d PRIMARY KEY,
nom_redsocial VARCHAR2(30 CHAR) CONSTRAINT NN_rsocial_d NOT NULL
) ; 

--Dimension Producto
CREATE TABLE d_producto (
ID_PRODUCTO  NUMBER CONSTRAINT PK_producto_d PRIMARY KEY,
precio NUMBER CONSTRAINT NN_producto_d NOT NULL,
Id_tipo_compra NUMBER CONSTRAINT NN_productoT_d NOT NULL,
desc_producto VARCHAR2(30 CHAR) CONSTRAINT NN_producto_desc_d NOT NULL
) ;

--------------------------------------------------
-------------------------FECHA
--Creacin de la secuencia del id para la fecha
CREATE SEQUENCE d_fecha_id_fecha_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

--- Dimension FECHA

CREATE TABLE d_fecha (
id_fecha NUMBER(10,0) CONSTRAINT PK_fecha_d PRIMARY KEY,
anyo NUMBER(10,0) NOT NULL,
mes NUMBER(10,0) NOT NULL,
desc_mes VARCHAR2(20 CHAR) NOT NULL,
semana_anyo NUMBER(10,0) NOT NULL,
dia NUMBER(10,0) NOT NULL,
desc_dia VARCHAR2(20 CHAR) NOT NULL,
hora NUMBER(10,0) NOT NULL,
minuto NUMBER(10,0) NOT NULL,
segundo NUMBER(10,0) NOT NULL
);

---------------------------------------------------------
-----  Creacion de Las tablas de hecho
---------------------------------------------------------
-------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_compra_vida.
-------***********************************************************************
CREATE SEQUENCE h_compra_vida_ID_comp_vida_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_compra_vida
CREATE TABLE h_compra_vida (
ID_comp_vida NUMBER CONSTRAINT PK_cv_v PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_cvu_v NOT NULL,
ID_PLATAFORMA NUMBER CONSTRAINT NN_cvp_v NOT NULL,
ID_PRODUCTO  NUMBER CONSTRAINT NN_cvpr_v NOT NULL,
ID_LEVEL NUMBER CONSTRAINT NN_cvl_v NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_cvf_v NOT NULL,
CONSTRAINT FK_user_hcom_v FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_platf_hcom_v FOREIGN KEY (ID_PLATAFORMA) REFERENCES d_plataforma (ID_PLATAFORMA),
CONSTRAINT FK_prod_hcom_v FOREIGN KEY (ID_PRODUCTO) REFERENCES d_producto (ID_PRODUCTO),
CONSTRAINT FK_lev_hcom_v FOREIGN KEY (ID_LEVEL) REFERENCES d_nivel (ID_LEVEL),
CONSTRAINT FK_fecha_hcom_v FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_vida:
CREATE INDEX D_USER_H_COMPRA_VIDA_FK_1 ON h_compra_vida(ID_USER);
CREATE INDEX D_PLATAFOFMA_H_COMPRAVIDA_FK_2 ON h_compra_vida(ID_PLATAFORMA);
CREATE INDEX D_PRODUCTO_H_COMPRAVIDA_FK_3 ON h_compra_vida(ID_PRODUCTO);
CREATE INDEX D_LEVEL_H_COMPRAVIDA_FK_4 ON h_compra_vida(ID_LEVEL);
CREATE INDEX D_FECHA_H_COMPRAVIDA_FK_5 ON h_compra_vida(id_fecha);

-------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_compra_ayuda.
-------***********************************************************************
CREATE SEQUENCE h_com_ayuda_ID_comp_ayuda_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_compra_ayuda
CREATE TABLE h_compra_ayuda (
ID_comp_ayuda NUMBER CONSTRAINT PK_ca_a PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_cu_a NOT NULL,
ID_PLATAFORMA NUMBER CONSTRAINT NN_cap_a NOT NULL,
ID_PRODUCTO  NUMBER CONSTRAINT NN_capr_a NOT NULL,
ID_LEVEL NUMBER CONSTRAINT NN_cal_a NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_caf_a NOT NULL,
CONSTRAINT FK_user_hcom_a FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_platf_hcom_a FOREIGN KEY (ID_PLATAFORMA) REFERENCES d_plataforma (ID_PLATAFORMA),
CONSTRAINT FK_prod_hcom_a FOREIGN KEY (ID_PRODUCTO) REFERENCES d_producto (ID_PRODUCTO),
CONSTRAINT FK_lev_hcom_a FOREIGN KEY (ID_LEVEL) REFERENCES d_nivel (ID_LEVEL),
CONSTRAINT FK_fecha_hcom_a FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_ayuda:
CREATE INDEX D_USER_H_COMPRA_ayuda_FK_1 ON h_compra_ayuda(ID_USER);
CREATE INDEX D_PLATFOFM_H_COMPRAayuda_FK_2 ON h_compra_ayuda(ID_PLATAFORMA);
CREATE INDEX D_PRODUCTO_H_COMPRAayuda_FK_3 ON h_compra_ayuda(ID_PRODUCTO);
CREATE INDEX D_LEVEL_H_COMPRAayuda_FK_4 ON h_compra_ayuda(ID_LEVEL);
CREATE INDEX D_FECHA_H_COMPRAayuda_FK_5 ON h_compra_ayuda(id_fecha);

-------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_Transferir_vida.
-------***********************************************************************
CREATE SEQUENCE h_transf_vida_ID_vida_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_Transferir_vida
CREATE TABLE h_Transferir_vida (
ID_transf_vida NUMBER CONSTRAINT PK_tv PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_tv NOT NULL,
ID_REDSOCIAL NUMBER CONSTRAINT NN_rst NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_ftv NOT NULL,
CONSTRAINT FK_user_ht_v FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_rs_ht_v FOREIGN KEY (ID_REDSOCIAL) REFERENCES d_redsocial (ID_REDSOCIAL),
CONSTRAINT FK_fecha_t_v FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_ayuda:
CREATE INDEX D_USER_H_TRANSF_vida_FK_1 ON h_Transferir_vida(ID_USER);
CREATE INDEX D_RS_H_TRANSF_vida_FK_4 ON h_Transferir_vida(ID_REDSOCIAL);
CREATE INDEX D_FECHA_H_TRANSF_vida_FK_5 ON h_Transferir_vida(id_fecha);

------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_Agregar_amigo.
-------***********************************************************************
CREATE SEQUENCE h_Agregar_amigo_ID_amigo_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_Agregar_amigo
CREATE TABLE h_Agregar_amigo (
ID_agregar_amigo NUMBER CONSTRAINT PK_aa PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_aa NOT NULL,
ID_REDSOCIAL NUMBER CONSTRAINT NN_rsaa NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_faa NOT NULL,
CONSTRAINT FK_user_aa FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_rs_aa FOREIGN KEY (ID_REDSOCIAL) REFERENCES d_redsocial (ID_REDSOCIAL),
CONSTRAINT FK_fecha_aa FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_ayuda:
CREATE INDEX D_USER_H_Agregar_amigo_FK_1 ON h_Agregar_amigo(ID_USER);
CREATE INDEX D_RS_H_Agregar_amigo_FK_4 ON h_Agregar_amigo(ID_REDSOCIAL);
CREATE INDEX D_FECHA_H_Agregar_amigo_FK_5 ON h_Agregar_amigo(id_fecha);

-------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_Baja.
-------***********************************************************************
CREATE SEQUENCE h_Baja_ID_amigo_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_Baja
CREATE TABLE h_Baja (
ID_baja NUMBER CONSTRAINT PK_baja PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_baja NOT NULL,
ID_LEVEL NUMBER CONSTRAINT NN_baja1 NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_baja2 NOT NULL,
CONSTRAINT FK_user_baja FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_level_baja FOREIGN KEY (ID_LEVEL) REFERENCES d_nivel (ID_LEVEL),
CONSTRAINT FK_fecha_baja FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_ayuda:
CREATE INDEX D_USER_h_Baja_FK_1 ON h_Baja(ID_USER);
CREATE INDEX D_LEVEL_h_baja_FK_1 ON h_Baja(ID_LEVEL);
CREATE INDEX D_FECHA_h_Baja_FK_1 ON h_Baja(id_fecha);

-------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_sup_nivel.
-------***********************************************************************
CREATE SEQUENCE h_sup_nivel_ID_amigo_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_sup_nivel
CREATE TABLE h_sup_nivel (
ID_sup_nivel NUMBER CONSTRAINT PK_sup_nivel PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_sup_nivel NOT NULL,
ID_LEVEL NUMBER CONSTRAINT NN_sup_nivel1 NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_sup_nivel2 NOT NULL,
CONSTRAINT FK_user_sup_nivel FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_level_sup_nivel FOREIGN KEY (ID_LEVEL) REFERENCES d_nivel (ID_LEVEL),
CONSTRAINT FK_fecha_sup_nivel FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_ayuda:
CREATE INDEX D_USER_h_sup_nivel_FK_1 ON h_sup_nivel(ID_USER);
CREATE INDEX D_LEVEL_h_sup_nivel_FK_1 ON h_sup_nivel(ID_LEVEL);
CREATE INDEX D_FECHA_h_sup_nivel_FK_1 ON h_sup_nivel(id_fecha);

-------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_UsarVida.
-------***********************************************************************
CREATE SEQUENCE h_UsarVida_ID_amigo_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_UsarVida
CREATE TABLE h_UsarVida (
ID_usarvida NUMBER CONSTRAINT PK_UsarVida PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_UsarVida NOT NULL,
ID_LEVEL NUMBER CONSTRAINT NN_UsarVida1 NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_UsarVida2 NOT NULL,
CONSTRAINT FK_user_UsarVida FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_level_UsarVida FOREIGN KEY (ID_LEVEL) REFERENCES d_nivel (ID_LEVEL),
CONSTRAINT FK_fecha_UsarVida FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_ayuda:
CREATE INDEX D_USER_h_UsarVida_FK_1 ON h_UsarVida(ID_USER);
CREATE INDEX D_LEVEL_h_UsarVida_FK_1 ON h_UsarVida(ID_LEVEL);
CREATE INDEX D_FECHA_h_UsarVida_FK_1 ON h_UsarVida(id_fecha);

-------***********************************************************************
--Creacin de la secuencia de la tabla de hecho h_Alta.
-------***********************************************************************
CREATE SEQUENCE h_Alta_ID_amigo_SEQ
MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1 NOCYCLE ;

-- Tabla de Hecho h_Alta
CREATE TABLE h_Alta (
ID_alta NUMBER CONSTRAINT PK_Alta PRIMARY KEY,
ID_USER NUMBER CONSTRAINT NN_Alta NOT NULL,
id_fecha NUMBER(10,0) CONSTRAINT NN_Alta2 NOT NULL,
CONSTRAINT FK_user_Alta FOREIGN KEY (Id_user) REFERENCES d_usuario (id_user),
CONSTRAINT FK_fecha_Alta FOREIGN KEY (id_fecha) REFERENCES d_fecha (id_fecha)
) ;

----Ahora se crea un ndice por cada dimensin en la tabla de hechos de comprar_ayuda:
CREATE INDEX D_USER_h_Alta_FK_1 ON h_Alta(ID_USER);
CREATE INDEX D_FECHA_h_Alta_FK_1 ON h_Alta(id_fecha);

--***************************************************************************************************************************
--*************** TRIGGERS del DWH ******************************************************************************************
--***************************************************************************************************************************
CREATE OR REPLACE TRIGGER d_fecha_id_fecha_TRG BEFORE INSERT ON d_fecha
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.id_fecha IS NULL THEN
SELECT d_fecha_id_fecha_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
-- If this is the first time this table have been inserted into (sequence == 1)
IF v_newVal = 1 THEN
--get the max indentity value from the table
SELECT NVL(max(id_fecha),0) INTO v_newVal FROM d_fecha;
v_newVal := v_newVal + 1;
--set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT d_fecha_id_fecha_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
-- assign the value from the sequence to emulate the identity column
:new.id_fecha := v_newVal;
END IF;
END;

---- Trigger de h_compra_vida

CREATE OR REPLACE TRIGGER h_compra_vida_id_compvida_TRG BEFORE INSERT ON h_compra_vida
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_comp_vida IS NULL THEN
SELECT h_compra_vida_ID_comp_vida_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_comp_vida),0) INTO v_newVal FROM h_compra_vida;
 v_newVal := v_newVal + 1;
--set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_compra_vida_ID_comp_vida_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_comp_vida := v_newVal;
END IF;
END;
---- Trigger de h_compra_ayuda
CREATE OR REPLACE TRIGGER h_comp_ayuda_id_compayuda_TRG BEFORE INSERT ON h_compra_ayuda
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_comp_ayuda IS NULL THEN
SELECT h_com_ayuda_ID_comp_ayuda_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_comp_ayuda),0) INTO v_newVal FROM h_compra_ayuda;
 v_newVal := v_newVal + 1;
--set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_com_ayuda_ID_comp_ayuda_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_comp_ayuda := v_newVal;
END IF;
END;

---- Trigger de h_Transferir_vida
CREATE OR REPLACE TRIGGER h_Transferir_vida BEFORE INSERT ON h_Transferir_vida
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_transf_vida IS NULL THEN
SELECT h_transf_vida_ID_vida_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_transf_vida),0) INTO v_newVal FROM h_Transferir_vida;
 v_newVal := v_newVal + 1;
--set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_transf_vida_ID_vida_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_transf_vida := v_newVal;
END IF;
END;

---- Trigger de h_Agregar_amigo
CREATE OR REPLACE TRIGGER h_agregar_amigo_id BEFORE INSERT ON h_Agregar_amigo
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_agregar_amigo IS NULL THEN
SELECT h_Agregar_amigo_ID_amigo_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_agregar_amigo),0) INTO v_newVal FROM h_Agregar_amigo;
 v_newVal := v_newVal + 1;
 --set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_Agregar_amigo_ID_amigo_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_agregar_amigo := v_newVal;
END IF;
END;

---- Trigger de h_Baja_usuario
CREATE OR REPLACE TRIGGER h_Baja_usuario_id BEFORE INSERT ON h_Baja
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_baja IS NULL THEN
SELECT h_Baja_ID_amigo_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_baja),0) INTO v_newVal FROM h_Baja;
 v_newVal := v_newVal + 1;
 --set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_Baja_ID_amigo_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_baja := v_newVal;
END IF;
END;

---- Trigger de h_Sup_Nivel
CREATE OR REPLACE TRIGGER h_superar_nivel_id BEFORE INSERT ON h_sup_nivel
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_sup_nivel IS NULL THEN
SELECT h_sup_nivel_ID_amigo_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_sup_nivel),0) INTO v_newVal FROM h_sup_nivel;
 v_newVal := v_newVal + 1;
 --set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_sup_nivel_ID_amigo_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_sup_nivel := v_newVal;
END IF;
END;

---- Trigger de h_Usar_Vida
CREATE OR REPLACE TRIGGER h_usar_vida_id BEFORE INSERT ON h_UsarVida
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_usarvida IS NULL THEN
SELECT h_UsarVida_ID_amigo_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_usarvida),0) INTO v_newVal FROM h_UsarVida;
 v_newVal := v_newVal + 1;
 --set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_UsarVida_ID_amigo_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_usarvida := v_newVal;
END IF;
END;

---- Trigger de h_alta_id
CREATE OR REPLACE TRIGGER h_alta_id BEFORE INSERT ON h_Alta
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
IF INSERTING AND :new.ID_alta IS NULL THEN
SELECT h_Alta_ID_amigo_SEQ.NEXTVAL INTO v_newVal FROM DUAL;

IF v_newVal = 1 THEN
 SELECT NVL(max(ID_alta),0) INTO v_newVal FROM h_Alta;
 v_newVal := v_newVal + 1;
 --set the sequence to that value
LOOP
EXIT WHEN v_incval>=v_newVal;
SELECT h_Alta_ID_amigo_SEQ.nextval INTO v_incval FROM dual;
END LOOP;
END IF;
:new.ID_alta := v_newVal;
END IF;
END;
